namespace DrawHeart
{
    public partial class Form1 : Form
    {
        public Form1()
        {
            DoubleBuffered = true;
            SetStyle(ControlStyles.ResizeRedraw | ControlStyles.OptimizedDoubleBuffer | ControlStyles.AllPaintingInWmPaint, true);
            InitializeComponent();
        }

        protected override void OnShown(EventArgs e)
        {
            base.OnShown(e);

            frmSetting setting = new frmSetting();
            setting.SetZoom += zoom => iZoom = Zoom = zoom;
            setting.SetColor += color => Color = color;
            setting.SetSpeed += speed => Speed = speed;
            setting.SetParticle += particle => Particle = particle;
            setting.SetFirstDiffusion += diffusion => FirstDiffusion = diffusion;
            setting.SetSecondDiffusion += diffusion => SecondDiffusion = diffusion;
            setting.Show();
        }

        /// <summary>
        /// Ƿ
        /// </summary>
        private bool goBack = false;
        /// <summary>
        /// ǰű
        /// </summary>
        private int iZoom = 10;
        /// <summary>
        /// ٶ
        /// </summary>
        private int Speed { get; set; } = 8;
        /// <summary>
        /// Ʊˢɫ
        /// </summary>
        private Brush Color { get; set; } = Brushes.LightPink;
        /// <summary>
        /// ű
        /// </summary>
        private int Zoom { get; set; } = 10;
        /// <summary>
        /// (αߺ)
        /// </summary>
        private int Particle { get; set; } = 20;
        /// <summary>
        /// һɢΧ
        /// </summary>
        private int FirstDiffusion { get; set; } = 10;
        /// <summary>
        /// ɢΧ
        /// </summary>
        private int SecondDiffusion { get; set; } = 30;

        protected override void OnPaint(PaintEventArgs e)
        {
            base.OnPaint(e);
            iZoom += goBack ? -1 : 1;
            if (iZoom >= (Zoom + 2) || iZoom <= (Zoom - 3))
                goBack = !goBack;
            Bitmap bmp = new Bitmap(Width, Height);
            Graphics g = Graphics.FromImage(bmp);  //뿴ƵĹ̿ʹ e.Graphics ֱӻڴ϶ǻͼƬ滻
            Random random = new Random();
            for (int i = 0; i < Particle * 100; i++)
            {
                double t = random.NextDouble() * 2 * Math.PI;
                double x = 16 * (Math.Pow(Math.Sin(t), 3));  //ߺX
                double y = -(13 * Math.Cos(t) - 5 * Math.Cos(2 * t) - 2 * Math.Cos(3 * t) - Math.Cos(4 * t));  //ߺY
                x *= iZoom;
                y *= iZoom;
                x += Width / 2;
                y += Height / 2;
                g.FillEllipse(Color, new Rectangle((int)x, (int)y, 10, 10));  //κ·ӵ
                if (i % 2 == 0)  //ɢ
                {
                    Random random2 = new Random();
                    int add1 = random2.Next(-FirstDiffusion, FirstDiffusion);
                    int add2 = random2.Next(-FirstDiffusion, FirstDiffusion);
                    g.FillEllipse(Color, new Rectangle((int)x + add1, (int)y + add2, 5, 5));  //һɢĵ
                    g.FillEllipse(Color, new Rectangle((int)x + add1, (int)y + add2, 5, 5));
                }
                if (i % 3 == 0)
                {
                    Random random2 = new Random();
                    int add1 = random2.Next(-SecondDiffusion, SecondDiffusion);
                    int add2 = random2.Next(-SecondDiffusion, SecondDiffusion);
                    g.FillEllipse(Color, new Rectangle((int)x + add1, (int)y + add2, 5, 5));  //ɢĵ
                    g.FillEllipse(Color, new Rectangle((int)x + add1, (int)y + add2, 5, 5));
                }
            }
            BackgroundImage = bmp;
            Thread.Sleep((10 - Speed) * 10);
        }
    }
}