﻿namespace DrawHeart
{
    public partial class frmSetting : Form
    {
        public Action<Brush> SetColor;
        public Action<int> SetZoom;
        public Action<int> SetSpeed;
        public Action<int> SetParticle;
        public Action<int> SetFirstDiffusion;
        public Action<int> SetSecondDiffusion;
        public frmSetting()
        {
            InitializeComponent();

            List<string> colors =new List<string>();
            var props = typeof(Brushes).GetProperties();
            for (int i = 0; i < props.Length; i++)
            {
                colors.Add(props[i].Name);
            }
            comboBox1.DataSource = colors;
            comboBox1.SelectedIndex = colors.IndexOf("LightPink");
        }

        private void comboBox1_SelectedIndexChanged(object sender, EventArgs e)
        {
            SetColor?.Invoke((Brush)typeof(Brushes).GetProperty(comboBox1.Text).GetValue(null));
        }

        private void textBox1_TextChanged(object sender, EventArgs e)
        {
            int iZoom = 10;
            if (int.TryParse(textBox1.Text, out int zoom))
                iZoom = zoom;
            SetZoom?.Invoke(iZoom);
        }

        private void trackBar1_Scroll(object sender, EventArgs e)
        {
            SetSpeed?.Invoke(trackBar1.Value);
        }

        private void trackBar2_Scroll(object sender, EventArgs e)
        {
            SetParticle.Invoke(trackBar2.Value);
        }

        private void textBox2_TextChanged(object sender, EventArgs e)
        {
            int iDiffusion = 10;
            if (int.TryParse(textBox2.Text, out int diffusion))
                iDiffusion = diffusion;
            SetFirstDiffusion?.Invoke(iDiffusion);
        }

        private void textBox3_TextChanged(object sender, EventArgs e)
        {
            int iDiffusion = 30;
            if (int.TryParse(textBox3.Text, out int diffusion))
                iDiffusion = diffusion;
            SetSecondDiffusion?.Invoke(iDiffusion);
        }
    }
}
